# org-felix-scholz-website-python-client
The api of my blog.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Package version: 1.0.1
- Build date: 2019-07-11T11:49:12.921785+02:00[Europe/Berlin]
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import website_python_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import website_python_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import website_python_client
from website_python_client.rest import ApiException
from pprint import pprint

configuration = website_python_client.Configuration()
# Configure API key authorization: ApiSecurity
configuration.api_key['X-API-FELIX-SCHOLZ-WEBSITE'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-API-FELIX-SCHOLZ-WEBSITE'] = 'Bearer'
configuration = website_python_client.Configuration()
# Configure API key authorization: ApiWriteSecurity
configuration.api_key['API-WRITE-TOKEN'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['API-WRITE-TOKEN'] = 'Bearer'

# create an instance of the API class
api_instance = website_python_client.CategoryApi(website_python_client.ApiClient(configuration))
identifier = 'identifier_example' # str | The post identifier, to identifie from source.
title = 'title_example' # str | The category title
slug = 'slug_example' # str | The category slug
parent_id = 56 # int | The parent category (optional)
before = 56 # int | The category before this (optional)
after = 56 # int | The category after this (optional)
source = 'source_example' # str | The category source (optional)
description = 'description_example' # str | The category description (optional)
acl = website_python_client.Acl() # Acl |  (optional)
tags = 56 # int | Add a tag to the category. (optional)
preview = 56 # int | id to a preview images for category (optional)

try:
    # create a new category
    api_response = api_instance.create_category(identifier, title, slug, parent_id=parent_id, before=before, after=after, source=source, description=description, acl=acl, tags=tags, preview=preview)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CategoryApi->create_category: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://www.felix-scholz.org/api/1.0.0*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CategoryApi* | [**create_category**](docs/CategoryApi.md#create_category) | **POST** /category | create a new category
*CategoryApi* | [**delete_category**](docs/CategoryApi.md#delete_category) | **DELETE** /category/{category} | delete a category
*CategoryApi* | [**get_category**](docs/CategoryApi.md#get_category) | **GET** /category/{category} | get a category
*CategoryApi* | [**list_categories**](docs/CategoryApi.md#list_categories) | **GET** /category | Returned all categories
*CategoryApi* | [**update_category**](docs/CategoryApi.md#update_category) | **PUT** /category/{category} | update a category
*FileApi* | [**create_file**](docs/FileApi.md#create_file) | **POST** /file | create a new file
*FileApi* | [**delete_file**](docs/FileApi.md#delete_file) | **DELETE** /file/{file} | Delete a file.
*FileApi* | [**get_file**](docs/FileApi.md#get_file) | **GET** /file/{file} | Get a File.
*FileApi* | [**list_file**](docs/FileApi.md#list_file) | **GET** /file | Returned all files
*FileApi* | [**update_file**](docs/FileApi.md#update_file) | **PUT** /file/{file} | Update a file.
*PostApi* | [**create_post**](docs/PostApi.md#create_post) | **POST** /post | create a new post
*PostApi* | [**delete_post**](docs/PostApi.md#delete_post) | **DELETE** /post/{post} | Delete the post by id
*PostApi* | [**list_post**](docs/PostApi.md#list_post) | **GET** /post | Returns all posts
*PostApi* | [**show_post**](docs/PostApi.md#show_post) | **GET** /post/{post} | Returns a posts
*PostApi* | [**update_post**](docs/PostApi.md#update_post) | **PUT** /post/{post} | Update the post by id
*TagApi* | [**create_tag**](docs/TagApi.md#create_tag) | **POST** /tag | create a new tag
*TagApi* | [**delete_tag**](docs/TagApi.md#delete_tag) | **DELETE** /tag/{tag} | delete a tag
*TagApi* | [**get_tag**](docs/TagApi.md#get_tag) | **GET** /tag/{tag} | get a tag
*TagApi* | [**list_tags**](docs/TagApi.md#list_tags) | **GET** /tag | Returned all tags
*TagApi* | [**update_tag**](docs/TagApi.md#update_tag) | **PUT** /tag/{tag} | update a tag


## Documentation For Models

 - [Acl](docs/Acl.md)
 - [Author](docs/Author.md)
 - [Category](docs/Category.md)
 - [CategoryPost](docs/CategoryPost.md)
 - [CategoryPut](docs/CategoryPut.md)
 - [File](docs/File.md)
 - [FileCreate](docs/FileCreate.md)
 - [FileIndex](docs/FileIndex.md)
 - [FileUpdate](docs/FileUpdate.md)
 - [Post](docs/Post.md)
 - [PostCreate](docs/PostCreate.md)
 - [PostUpdate](docs/PostUpdate.md)
 - [Tag](docs/Tag.md)
 - [TagCreate](docs/TagCreate.md)
 - [TagUpdate](docs/TagUpdate.md)


## Documentation For Authorization


## ApiReadSecurity

- **Type**: API key
- **API key parameter name**: API-READ-TOKEN
- **Location**: HTTP header


## ApiSecurity

- **Type**: API key
- **API key parameter name**: X-API-FELIX-SCHOLZ-WEBSITE
- **Location**: HTTP header


## ApiWriteSecurity

- **Type**: API key
- **API key parameter name**: API-WRITE-TOKEN
- **Location**: HTTP header


## Author

felix@felix-scholz.org


